#include <bits/stdc++.h>
#define int int64_t

using namespace std;

int f(int a){
    vector<int> d;
    int ans = a;
    if(a != 1) ans ^= 1;
    if(a == 2) return 3;
    if(a%2 == 0){
        ans ^= a/2;
        if(a/2 != 2) ans ^= 2;
    }
    for(int i = 3; i*i <= a; i++){
        if(a%i == 0){
            ans ^= a/i;
            if(a/i != i) ans ^= i;
        }
    }

    return ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n, k; cin >> n >> k;

    vector<int> v(n);
    for(int i = 0; i < k; i++){
        cin >> v[i];
        cout << f(v[i]) << ' ';
    }
    return 0;
}